import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Course, CourseParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询课程管理
 */
export async function pageCourse(params: CourseParam) {
  const res = await request.get<ApiResult<PageResult<Course>>>(
    MODULES_API_URL + '/booking/course/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询课程管理列表
 */
export async function listCourse(params?: CourseParam) {
  const res = await request.get<ApiResult<Course[]>>(
    MODULES_API_URL + '/booking/course',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加课程管理
 */
export async function addCourse(data: Course) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改课程管理
 */
export async function updateCourse(data: Course) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除课程管理
 */
export async function removeCourse(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除课程管理
 */
export async function removeBatchCourse(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询课程管理
 */
export async function getCourse(id: number) {
  const res = await request.get<ApiResult<Course>>(
    MODULES_API_URL + '/booking/course/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
